---
title: Region Analysis
author:
date: 2024-12-05
...

# Region Analysis {#region-analysis}

## plugins.region.node (`DATA`) {#node}

> [`node`](#node)  `::=` `#node`
  

## plugins.region.range (`DATA`) {#range}

> [`range`](#range)  `::=` `{` `"label"` `:` _string_ , `"offset"` `:`
  _number_ , `"length"` `:` _number_ , `"cells"` `:` _number_ , `"data"` `:`
  [`node`](index.md#node)  `}`
  

## plugins.region.region (`DATA`) {#region}

> [`region`](#region)  `::=` `{` `"node"` `:` [`node`](index.md#node)  ,
  `"roots"` `:` _string_ `[]` , `"labels"` `:` _string_ `[]` , `"parents"`
  `:` [`node`](index.md#node)  `[]` , `"sizeof"` `:` _number_ , `"ranges"`
  `:` [`range`](index.md#range)  `[]` , `"pointed"` `:?`
  [`node`](index.md#node)  , `"reads"` `:` _boolean_ , `"writes"` `:`
  _boolean_ , `"bytes"` `:` _boolean_ , `"label"` `:` _string_ , `"title"`
  `:` _string_ `}`
  

## plugins.region.updated (`SIGNAL`) {#updated}

Region Analysis Updated


## plugins.region.compute (`EXEC`) {#compute}

Compute regions for the given declaration


> _input_ `::=` [`decl`](../../kernel/ast.md#decl) 
  

> _output_ `::=` _null_
  

## plugins.region.regions (`GET`) {#regions}

Returns computed regions for the given declaration


> _input_ `::=` [`decl`](../../kernel/ast.md#decl) 
  

> _output_ `::=` [`region`](index.md#region)  `[]`
  

> _signals_
  

* `plugins.region.updated`


## plugins.region.regionsAt (`GET`) {#regionsat}

Compute regions at the given marker program point


> _input_ `::=` [`marker`](../../kernel/ast.md#marker) 
  

> _output_ `::=` [`region`](index.md#region)  `[]`
  

> _signals_
  

* `plugins.region.updated`


## plugins.region.localize (`GET`) {#localize}

Localize the marker in its map


> _input_ `::=` [`marker`](../../kernel/ast.md#marker) 
  

> _output_ `::=` [`node`](index.md#node)  `?`
  

> _signals_
  

* `plugins.region.updated`
